\subsection*{Derivation of parameter adjustment by backward tuning}

We consider a $N$-dimensional vectorial causal discrete-time dynamical system observed a $T$ samples, defined by a recurrent equation:
\eqline{x_n(t) = {}_{\bf w}f_n(t, \cdots x_m(s) \cdots), 0 \le s < t < T, 0 \le n < N, 0 \le m < N,}
parameterized by K static parameters ${\bf w} \in {\cal R}^K$.
\\ - This includes $N_i$ ``input'' that are simply $x_n(t) = f_n(t)$ without parameter and state dependencies.
\\ - This includes $N_o$ ``output'' that are simply $x_n(t)$ that are observable, by convention for $0 \le n < N_o \le N$.

The goal is to adjust these parameters minimizing:
\eqline{\min_{\bf w x z} {\cal L}({\bf w x z}), {\cal L}(\cdot) \deq
  \underbrace{c({\bf x})}_{\mbox{cost function}} +
  \underbrace{\sum_{nt} z_n(t) \, (x_n(t) - {}_{\bf w}f_n(t, \cdots))}_{\mbox{system dynamic}} +
  \underbrace{\|{\bf w} - \hat{\bf w}\|_{{\bf \Lambda}(\hat{\bf w}, \hat{\bf x}, \hat{\bf z})^{-1}}^2}_{\mbox{parameter regularization}}}
where $z_n(t)$ are Lagrange multipliers, used to derive while $\hat{\bf w}, \hat{\bf x}, \hat{\bf z}$ stands for initial or previous estimates of these values. Here ${\bf \Lambda}(\cdot)$ is restrained to a diagonal matrix of diagonal element $\upsilon \, l_k$, where $\upsilon$ is the usual global weight adjustment gain, here \href{https://line.gitlabpages.inria.fr/aide-group/backwardtuning/weightadjustment.pdf}{\underline{auto-tuned}}.

This yields the following equations, from the normal equations:
\begin{itemize}
  \item {\em forward simulation}: $x_n(t) \leftarrow {}_{\bf w} f_n(t, \cdots), n \in \{0, N\{, t \in \{0, T\{$ (from $\partial_{z_n(t)} {\cal L} = 0$);
  \item {\em backward tuning}: $z_n(t) \leftarrow - \partial_{x_n(t)}c(\cdot)  + \sum_{ms} z_m(s) \, \partial_{x_n(t)} {}_{\bf w}f_m(s, \cdots), n \in \{0, N\{, t \in \}T, 0\}$ (from $\partial_{x_n(t)} {\cal L} = 0$);
  \item {\em weight adjustment}: $w_k \leftarrow \hat{w}_k + \upsilon \, l_k \, \sum_{nt} z_n(t) \, \partial_{w_k}{}_{\bf w}f_n(t, \cdots)$ (from $\partial_{\bf w} {\cal L} = 0$).
\end{itemize}

This has been developed in details at a rather general level in \cite{vieville_recurrent_2017}. This is a simplified application of the Pontryagin's minimum principle, well-known in control theory \cite{astrom_theory_1983}, generalizing an idea drafted by \cite{le_cunn_yann_theoretical_1988}.

If $l_k = \frac{(\hat{w}_{k,\bullet} + |\hat{w}_k|)^2}{(2 \, \hat{w}_{k,\bullet} + |\hat{w}_k|)}$, this corresponds to \href{https://line.gitlabpages.inria.fr/aide-group/backwardtuning/quadlin.pdf}{\underline{quadlin}} regularization profile.

